/*
** Module   : CommonFile.java
** Abstract : Defines common APIs used by the FILE-INFO and procedure handles.
**
** Copyright (c) 2013, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** -#- -I- --Date-- -----------------------Description------------------------
** 001 CA  20130112 Created initial version.
*/

package com.goldencode.p2j.util;

/**
 * Exposes the following methods or attributes, common for the FILE-INFO and
 * PROCEDURE handles:
 * <table>
 * <tr>
 *    <th>attribute or method</th>
 *    <th>API</th>
 * </tr>
 * <tr>
 *    <td>FILE-NAME</td>
 *    <td>{@link #getFileName()}</td>
 * </tr>
 * </table>
 * This interface is used as a returned type by the 
 * {@link handle#unwrapFile(handle)} API, which, depending on the 
 * handle's state and type, it either returns an 
 * {@link FileSystemOps#asHandle()} instance (for FILE-INFO handles) or an 
 * {@link ExternalProgramWrapper} instance (for PROCEDURE handles), or a 
 * dynamic proxy using {@link handle#invalidProxy}. 
 */
public interface CommonFile
{
   /**
    * Get the <code>file-name</code> attribute of this handle.
    * 
    * @return   See above.
    */
   public character getFileName();
}